/******************************************************************************
*
*       Attend - Scheduler for Windows 95
*		
*
*    	PROGRAM: Main.cpp
*
*    	PURPOSE: Remind about some things
*
******************************************************************************/
#include <windows.h>    // includes basic windows functionality
#include <windowsx.h>
#include <winuser.h>
#include <commctrl.h>   // includes the common control header
#include <stdio.h>
#include <string.h>
#include "resource.h"
#include "..\CmnHdr.h" // Was create by Jephry Rihter
#include "..\array.h" // Was create by Jury Shvetsov
#include "GlobDef.h"

#define MYWM_NOTIFYICON    (WM_APP+100) // It's our message

//     Tray Icon
#define HANDLE_MYWM_NOTIFYICON(hwnd, wParam, lParam, fn) \
        ((fn)((hwnd),(int)(wParam),(int)(lParam)),0L);
#define FORWARD_MYWM_NOTIFYICON(hwnd,wP,id,fn) \
	    (void)(fn)((hwnd),MYWM_NOTIFYICON,(WPARAM) wP,(LPARAM) id);


//-----------------------------------------------------------------

#define POPMENU_EXIT 4
#define POPMENU_OPTIONS 2
#define POPMENU_RESTORE 1


#define FILENAMEED   	106
#define DISABLETASK		109
#define FREQOFTASK		107

#define ATBOOT			102
#define DATE			111
#define DAY				112
#define DAYOFWEEK       110
#define MSGEDIT         105
#define ONCLOSE         101
#define RUNPROGRAM      104
#define SHOWMESSAGE     103

#define SOUND			100
#define TIME            108


// declaration functions from Proptls ///////////////////////

void InitPropDialog(HWND hwnd,int TaskType);
void SetVisibleState(HWND hwnd,int Freq);
BOOL StoredUserSettings(HWND hwnd);
void LoadTask(HWND hwnd);
void CreateNewListViewItem(HWND hwnd);;
void ChangeListViewItem(HWND hwnd);
void EraseListViewItem(int Index);
void DisableCurrentTask(int Idx);
BOOL ReadMyData();
void WriteMyData(HWND hwnd);
void AppendItemInListView(HWND hwnd);
void ClearFlagTaskWasRun();
BOOL ReadMainWindowSettings();

// declaration from Log.cpp

void ShowLog();
void AddRecordInLog(int Index);

//-------------------------


#define ID_SPIN 999

extern HWND hSpinWnd;

// declaration from copy ------

void CopyTask();


// declaration functions from TimerTls ///////////////////////


void NotifyUserAboutNoStartedTasks();
BOOL TimeToStart(int i);
DWORD WINAPI MyThreadFunction(LPVOID lpParameter);
void CheckDate();

//------------------------------------------------------------


POSITION_SETTINGS	PosInfo; // here, we stored position of the main window



long APIENTRY 	MainWndProc( HWND, UINT, UINT, LONG );

//functions that handler the MainWnd messages
void	MainWndProc_OnPaint(HWND hwnd);
void	MainWndProc_OnSize(HWND hwnd,UINT state,int cx,int cy);
void	MainWndProc_OnDestroy(HWND hwnd);
void	MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
void	MainWndProc_OnSysCommand(HWND hwnd, UINT cmd, int x, int y);
BOOL	MainWndProc_OnCreate(HWND hwnd,LPCREATESTRUCT lpCreateStruct);
//--------------------------------------------

BOOL	InitApplication( HANDLE );
HWND	InitInstance( HANDLE, int );

// General cursor manipulation
HCURSOR 			hSaveCursor;
HCURSOR 			hHourGlass;


HWND				hWndListView; // Handle of the ListView
HWND				hStWin; // Handle of Status Window
HWND				hOptDlg; // Handle of Options DialogBox 
HWND				hPropDlg; // Handle of Prop DialogBox 
HIMAGELIST			himlSmall; // Handle of ImageList

HINSTANCE			hInst; // Our Global hInstance
HMENU				hPopMenu; // Handle of Popup menu near Tray Icon

BOOLEAN				ViewStBar = TRUE; // Show StatusBar?
BOOLEAN				ViewGrLine = TRUE; // Show Gridlines in ListView? 
BOOLEAN				EnableAttendant = TRUE; // EnableAttendant?

BOOLEAN				NewTaskMode;
BOOLEAN				CopyTaskMode;
BOOLEAN				FirstTimerStart = TRUE;
BOOLEAN				AtBootTime = TRUE;

// For info saving
TCHAR				szFileName[512];
BOOLEAN				FileChosen = FALSE;

//-------------------------------------

// Declaration from sorting.cpp
void SortByStartTime(HWND hwnd);
void SortByCreatedTime(HWND hwnd);

//-----------------------------


UINT				CurrentTaskNumber; //   

char				szHomeDir[512]; //  

char				g_szAppName[10] = "Attendant"; // Caption

PROG_INFO			MyProgInfo = { "1.0",0,FALSE,TRUE,TRUE,TRUE,0 };

CRITICAL_SECTION    CrSec; 


//    
SYSTEMTIME			CurrentDate;



//    


ARRAY<TASK_RECORD> PTasks;


void Get_Position_Settings()
{
  PosInfo.top		= CW_USEDEFAULT; 
  PosInfo.left		= CW_USEDEFAULT; 
  PosInfo.width		= CW_USEDEFAULT; 
  PosInfo.height	= CW_USEDEFAULT; 

//      Ob  
  ReadMainWindowSettings();

}



/////////////////////////////////////////////////////////////////////////////



void RemoveSound()
{

  RegDeleteKey(HKEY_CURRENT_USER,"AppEvents\\Schemes\\Apps\\.Default\\AttendantSound");
  RegDeleteKey(HKEY_CURRENT_USER,"AppEvents\\EventLabels\\AttendantSound");
  
}



/////////////////////////////////////////////////////////////////////////////



void AddSound()
{
  HKEY hKey;
  DWORD  Dispose;
  
  RegCreateKeyEx(HKEY_CURRENT_USER,
	             "AppEvents\\Schemes\\Apps\\.Default\\AttendantSound",
				 NULL,NULL,REG_OPTION_NON_VOLATILE ,
				 KEY_ALL_ACCESS,NULL,&hKey,&Dispose);
  RegCreateKeyEx(hKey,".current",NULL,NULL,
	             REG_OPTION_NON_VOLATILE ,KEY_ALL_ACCESS,NULL,
				 &hKey,&Dispose);

  RegFlushKey(hKey);
  RegCloseKey(hKey);
  
  RegCreateKeyEx(HKEY_CURRENT_USER,
	             "AppEvents\\EventLabels\\AttendantSound",NULL,
				 NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
				 NULL,&hKey,&Dispose);
  
  
  RegSetValueEx(hKey,"",0,REG_SZ,(const unsigned char *)"Attendant Message",512); 

  RegFlushKey(hKey);
  RegCloseKey(hKey);
}



/////////////////////////////////////////////////////////////////////////////



void RemoveRunAtBoot()
{
  HKEY hKey;
  
  RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run",0,KEY_ALL_ACCESS,&hKey);
  RegDeleteValue(hKey,"Attendant");

    
  RegFlushKey(hKey);
  RegCloseKey(hKey);

}



/////////////////////////////////////////////////////////////////////////////




void RunAtBoot()
{
  char szBuf[512] = "";

  HKEY hKey;
  
  RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run",0,KEY_ALL_ACCESS,&hKey);
    
  strcat(szBuf,szHomeDir);
  strcat(szBuf,"\\attend.exe");

  RegSetValueEx(hKey,"Attendant",0,REG_SZ,(const unsigned char *)szBuf,512); 

  RegFlushKey(hKey);
  RegCloseKey(hKey);
}




/////////////////////////////////////////////////////////////////////////////


void GetHomeDir()
{
  HKEY hKey;
  LONG	 l;	
  char   szPath[512] = "";

  
  unsigned char   chBuf[512];
  unsigned char   *pchBuf = chBuf;

  DWORD  ParamSize;

  RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run",0,KEY_ALL_ACCESS,&hKey);
  
  ParamSize = sizeof (chBuf);
  l = RegQueryValueEx(hKey,"Attendant",NULL,NULL,pchBuf,&ParamSize);

  if(l != ERROR_SUCCESS)GetCurrentDirectory(512,szHomeDir);

  else
  {	  
    
    strupr((char *)chBuf); 
	char *p;
	int i;
	p = strstr((const char *)chBuf,"ATTEND.EXE");

    i = p - (char *)chBuf;

	strncpy(szPath,(const char *)chBuf,i-1);

    strcpy(szHomeDir,szPath);

  }
  
  RegCloseKey(hKey);
  
}



/////////////////////////////////////////////////////////////////////////////


void SaveFile(HWND hWnd,BOOL SaveAs)
{

	OPENFILENAME	SaveFileName;
	char			szFile[512] = "", fieldtext[512], output[2048];
	FILE			*hFile;
	int				numitems;
	int				row, subitem;

	if( SaveAs || !FileChosen ) {
		SaveFileName.lStructSize       = sizeof (SaveFileName);
		SaveFileName.hwndOwner         = hWnd;
		SaveFileName.hInstance         = hInst;
		SaveFileName.lpstrFilter       = "(*.*)";
		SaveFileName.lpstrCustomFilter = (LPTSTR)NULL;
		SaveFileName.nMaxCustFilter    = 0L;
		SaveFileName.nFilterIndex      = 1L;
		SaveFileName.lpstrFile         = szFile;
		SaveFileName.nMaxFile          = 256;
		SaveFileName.lpstrFileTitle    = NULL;
		SaveFileName.nMaxFileTitle     = 0;
		SaveFileName.lpstrInitialDir   = NULL;
		SaveFileName.lpstrTitle        = "Save File Info...";
		SaveFileName.nFileOffset       = 0;
		SaveFileName.nFileExtension    = 0;
		SaveFileName.lpstrDefExt       = "";
		SaveFileName.lpfnHook		   = NULL;
 		SaveFileName.Flags = OFN_LONGNAMES|OFN_HIDEREADONLY;

		if( !GetSaveFileName( &SaveFileName )) 
			return;
	} else 
		// open previous szFile
		strcpy( szFile, szFileName );

    //    
    if( SaveAs || !FileChosen ){
      WIN32_FIND_DATA FindFileData; 
	  HANDLE hF;

      hF = FindFirstFile(szFile,&FindFileData);
	  if(hF != INVALID_HANDLE_VALUE){
		  if(MessageBox(hWnd,"File already exists. Do you \nreally want to rewrite it?","Attendant",MB_YESNO | MB_ICONWARNING)==IDNO)return;

	  }

	}


	// open the file
	hFile = fopen( szFile, "w" );
	if( !hFile ) {
		MessageBox(	NULL, "Create File Failed.",
				"Save Error", MB_OK|MB_ICONSTOP );
		return;
	}
	// post hourglass icon
	SetCapture(hWnd);
	hSaveCursor = SetCursor(hHourGlass);

	numitems = ListView_GetItemCount(hWndListView);
	for ( row = 0; row < numitems; row++ )  {
		output[0] = 0;
		for( subitem = 2; subitem >= 0; subitem-- ) {
			fieldtext[0] = 0;
			ListView_GetItemText( hWndListView, row, subitem, fieldtext, 256 );
			strcat( output, fieldtext );
			strcat( output, "\t" );
		}
		fprintf( hFile, "%s\n", output );
	}
	fclose( hFile );
	strcpy( szFileName, szFile );
	FileChosen = TRUE;
	SetCursor( hSaveCursor );
	ReleaseCapture(); 
}



/////////////////////////////////////////////////////////////////////////////



BOOL TrayMessage(HWND hDlg, DWORD dwMessage, UINT uID, HICON hIcon, PSTR pszTip)
{
   BOOL				res;
   NOTIFYICONDATA	tnd;

   tnd.cbSize = sizeof(NOTIFYICONDATA);
   tnd.hWnd = hDlg;
   tnd.uID = uID;

   tnd.uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP;
   tnd.uCallbackMessage = MYWM_NOTIFYICON;
   tnd.hIcon = hIcon;
   if (pszTip)
   {
     lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
   }
    else
   {
     tnd.szTip[0] = '\0';
   }

   res = Shell_NotifyIcon(dwMessage, &tnd);

   if (hIcon) DestroyIcon(hIcon);
      return res;
}



///////////////////////////////////////////////////////////////////////////// 	 



HWND CreateList( HWND hWndParent )                                     
{

	RECT		rc;         	  	// rectangle for setting size of window
	LV_COLUMN	lvC;				// list view column structure
	DWORD		j;
	static struct {
		TCHAR *	Label;	// title of column
		DWORD	Width;	// width of column in pixels
		DWORD	Fmt;
	} column[] = {
		
		{	"Subject"	,	200		},		
		{	"Frequency"	,	120		},
		{	"Time"		,	100		},
		
	};


	
	// Get the size and position of the parent window.
	GetClientRect( hWndParent, &rc );

    RECT StRec;
	BOOL B = SendMessage(hStWin,SB_GETRECT,0,(LPARAM)&StRec);

	// Create the list view window
	hWndListView = CreateWindowEx( 0L, WC_LISTVIEW, "", 
								WS_VISIBLE | WS_CHILD | WS_BORDER | LVS_REPORT |
								    WS_EX_CLIENTEDGE | LVS_SINGLESEL,	// styles
								0, 0, rc.right - rc.left, rc.bottom - rc.top - (StRec.bottom - StRec.top ) ,
								hWndParent,	NULL, hInst, NULL );
	if ( hWndListView == NULL )
		return NULL;

	// Initialize columns
	lvC.mask	= LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvC.fmt		= LVCFMT_LEFT;	// left-align column

	// Add the columns.
	for ( j = 0; j < sizeof column/sizeof column[0]; ++j )  {
		lvC.iSubItem	= j;
		lvC.cx			= column[j].Width;
	 	lvC.pszText		= column[j].Label;
		if ( ListView_InsertColumn( hWndListView, j, &lvC ) == -1 )
			return NULL;
	}

	return hWndListView;
}



/////////////////////////////////////////////////////////////////////////////


void OpenFile(HWND hwnd)
{
  OPENFILENAME OpenFileName;
  char szFile[256] = "";

  OpenFileName.lStructSize			= sizeof(OpenFileName);
  OpenFileName.hwndOwner			= hwnd;
  OpenFileName.hInstance			= hInst;
  OpenFileName.lpstrFilter			= "";
  OpenFileName.lpstrCustomFilter	= (LPSTR)NULL;
  OpenFileName.nMaxCustFilter		= 0L;
  OpenFileName.nFilterIndex			= 1L;
  OpenFileName.lpstrFile			= szFile;
  OpenFileName.nMaxFile				= 256;
  OpenFileName.lpstrFileTitle		= NULL;
  OpenFileName.nMaxFileTitle		= 0;
  OpenFileName.lpstrInitialDir		= NULL;
  OpenFileName.lpstrTitle			= "Open File";
  OpenFileName.nFileOffset			= 0;
  OpenFileName.nFileExtension		= 0;
  OpenFileName.lpstrDefExt			= "*.*";
  OpenFileName.lpfnHook				= NULL;
  OpenFileName.Flags = OFN_LONGNAMES|OFN_HIDEREADONLY;

  if (!GetOpenFileName( &OpenFileName )) return;

  SetWindowText(GetDlgItem(hwnd,IDC_EDIT_ED),szFile);


  return;


}



/////////////////////////////////////////////////////////////////////////////




BOOL AboutDlg_OnInitDialog(HWND hwnd,HWND hwndFocus,LPARAM lParam)
{
	
    

	return TRUE;

}



/////////////////////////////////////////////////////////////////////////////



void AboutDlg_OnSysCommand(HWND hwnd, UINT cmd, int x, int y)
{

  switch(cmd)
  {
	  case SC_CLOSE:	
        
		EndDialog(hwnd,0);    

	  break;

   }
   FORWARD_WM_SYSCOMMAND(hwnd,cmd,x,y,DefWindowProc);
  

}



/////////////////////////////////////////////////////////////////////////////



void AboutDlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT CodeNotify)
{

  switch(id)
  {
	  case IDC_OK:	
        
		EndDialog(hwnd,0);    

	  break;

   }

   FORWARD_WM_COMMAND(hwnd,id,hwndCtl,CodeNotify,DefWindowProc);
  

}




/////////////////////////////////////////////////////////////////////////////



BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{

  switch(uMsg)
  {
      chHANDLE_DLGMSG(hDlg,WM_INITDIALOG,AboutDlg_OnInitDialog);
	  chHANDLE_DLGMSG(hDlg,WM_SYSCOMMAND,AboutDlg_OnSysCommand);
  	  chHANDLE_DLGMSG(hDlg,WM_COMMAND,AboutDlg_OnCommand);
  }

  return FALSE;

}



/////////////////////////////////////////////////////////////////////////////



BOOL PropDlg_OnInitDialog(HWND hwnd,HWND hwndFocus,LPARAM lParam)
{

	//  caption
   if(CopyTaskMode)SetWindowText(hwnd,"Copy task");
   if(NewTaskMode)SetWindowText(hwnd,"New task");

   //  :)
   if(!CopyTaskMode && !NewTaskMode)SetWindowText(hwnd,"Edit task");
   
   InitPropDialog(hwnd,0); //   
   

   if(NewTaskMode == FALSE)LoadTask(hwnd); 

   
   hPropDlg = hwnd; // Handle   
   
   return TRUE;

}



/////////////////////////////////////////////////////////////////////////////



void PropDlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT CodeNotify)
{

	switch(id)
	{
	  case IDOK:


        //    ,   
		//   ,     
		//     ,   CurrentTaskNumber
        //      ListView, 
        //      
		  
		if(NewTaskMode || CopyTaskMode)CurrentTaskNumber = PTasks.Size() - 1; 

 	    if(!StoredUserSettings(hwnd)) return;
		
		EndDialog(hwnd,0);
		
		if(NewTaskMode || CopyTaskMode)CreateNewListViewItem(hwnd);
		
		else ChangeListViewItem(hwnd); 

        NewTaskMode = FALSE;
        CopyTaskMode = FALSE;


		// 
        BOOL bTmpState;
                    
		bTmpState = EnableAttendant;

		EnableAttendant = FALSE;
          
		if(MyProgInfo.SortByCreatedTime)SortByCreatedTime(hwnd);else
		   SortByStartTime(hwnd);
	
		
  	    EnableAttendant = bTmpState;


		WriteMyData(hwnd);

	    break;
	  case IDCANCEL:

//     
		if(NewTaskMode)PTasks.Delete(PTasks.Size()-1);
		NewTaskMode = FALSE;
		CopyTaskMode = FALSE;


		EndDialog(hwnd,0);

	  break;		
      case IDC_ONETIME_RB:
		SetVisibleState(hwnd,0);

	  break;
      case IDC_DAILY_RB:
		SetVisibleState(hwnd,1);

	  break;
      case IDC_MONTHLY_RB:
		SetVisibleState(hwnd,2);

	  break;
	  case IDC_MSG_RB:

  	    EnableWindow(GetDlgItem(hwnd,IDC_OPEN_BTN),FALSE);    

      break;
	  case IDC_PROG_RB:
        EnableWindow(GetDlgItem(hwnd,IDC_OPEN_BTN),TRUE);

	  break;		  
	  case IDC_TIME_RB:
        EnableWindow(GetDlgItem(hwnd,IDC_TIME_ED),TRUE);
	    EnableWindow(GetDlgItem(hwnd,ID_SPIN),TRUE);
		
      break;
	  case IDC_ATBOOT_RB:
		EnableWindow(GetDlgItem(hwnd,IDC_TIME_ED),FALSE);
		EnableWindow(GetDlgItem(hwnd,ID_SPIN),FALSE);

      break;
      case IDC_OPEN_BTN:
        OpenFile(hwnd);

	  case IDC_TIME_ED:
        
		if(CodeNotify == EN_UPDATE);
		else ;
		  
	  break;  

	}

}




/////////////////////////////////////////////////////////////////////////////





BOOL CALLBACK PropDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{

   switch(uMsg)
   {
      chHANDLE_DLGMSG(hDlg,WM_INITDIALOG,PropDlg_OnInitDialog);
	  chHANDLE_DLGMSG(hDlg,WM_COMMAND,PropDlg_OnCommand);
   }

   // Create an array of control identifiers and context identifiers. 

static DWORD aIds[] = { 
    IDC_EDIT_ED,   FILENAMEED, 
    IDC_DISTASK,   DISABLETASK,
    IDC_FREQ_GB,   FREQOFTASK,
	IDC_TIME_GB,   TIME,
	IDC_MSG_RB,    SHOWMESSAGE,
	IDC_PROG_RB,   RUNPROGRAM

}; 
 
switch (uMsg) { 
    case WM_HELP: 
        WinHelp((HWND)((LPHELPINFO) lParam)->hItemHandle, "attprj.hlp", 
            HELP_WM_HELP, (DWORD) (LPSTR) aIds); 
        break; 
 
    case WM_CONTEXTMENU: 
        WinHelp((HWND) wParam, "attprj.hlp", HELP_CONTEXTMENU, 
            (DWORD) (LPVOID) aIds); 
        break; 
    } 
 
return FALSE; 


   
}



/////////////////////////////////////////////////////////////////////////////



BOOL OptionDlg_OnInitDialog(HWND hwnd,HWND hwndFocus,LPARAM lParam)
{
	hOptDlg = hwnd;


	(MyProgInfo.MinimizeOnClose)?SendDlgItemMessage(hwnd,IDC_MINTOTRAY,BM_SETCHECK,BST_CHECKED,0):
				                 SendDlgItemMessage(hwnd,IDC_SHUTDOWN,BM_SETCHECK,BST_CHECKED,0);

    Button_SetCheck(GetDlgItem(hwnd,IDC_RUNATBOOT),MyProgInfo.RunAtBoot);
    Button_SetCheck(GetDlgItem(hwnd,IDC_SOUND),MyProgInfo.EnableSound);


	return TRUE;

}



/////////////////////////////////////////////////////////////////////////////



void OptionDlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT CodeNotify)
{

	switch(id)
	{
	  case IDOK:
        MyProgInfo.MinimizeOnClose = SendDlgItemMessage(hwnd,IDC_MINTOTRAY,BM_GETCHECK,0,0);
        MyProgInfo.EnableSound = Button_GetCheck(GetDlgItem(hwnd,IDC_SOUND));
        MyProgInfo.RunAtBoot = Button_GetCheck(GetDlgItem(hwnd,IDC_RUNATBOOT));

		if(MyProgInfo.RunAtBoot) RunAtBoot();
		else RemoveRunAtBoot();
		
		if(MyProgInfo.EnableSound) AddSound();
		else RemoveSound();


	    EndDialog(hwnd,0);
        
	    break;
	  case IDCANCEL:
        EndDialog(hwnd,0);
	  break;		
	}
  

}



/////////////////////////////////////////////////////////////////////////////



BOOL CALLBACK OptionDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{

  switch(uMsg)
  {
      chHANDLE_DLGMSG(hDlg,WM_INITDIALOG,OptionDlg_OnInitDialog);
	  chHANDLE_DLGMSG(hDlg,WM_COMMAND,OptionDlg_OnCommand);
  }

   // Create an array of control identifiers and context identifiers. 

static DWORD aIds[] = { 
    IDC_RUNATBOOT,   ATBOOT, 
    IDC_ONCLOSE_RG,  ONCLOSE,
    IDC_SOUND,       SOUND

}; 
 
switch (uMsg) { 
    case WM_HELP: 
        WinHelp((HWND)((LPHELPINFO) lParam)->hItemHandle, "attprj.hlp", 
            HELP_WM_HELP, (DWORD) (LPSTR) aIds); 
        break; 
 
    case WM_CONTEXTMENU: 
        WinHelp((HWND) wParam, "attprj.hlp", HELP_CONTEXTMENU, 
            (DWORD) (LPVOID) aIds); 
        break; 
    } 


  return FALSE;

}



/////////////////////////////////////////////////////////////////////////////



BOOL MainWndProc_OnCreate(HWND hwnd,LPCREATESTRUCT lpCreateStruct)
{

   UINT				  wId;

   //   
   GetLocalTime(&CurrentDate);


   // get hourglass cursor ready
   hHourGlass = LoadCursor( NULL, IDC_WAIT );

   // Ensure that the common control DLL is loaded.
   InitCommonControls();

   
   hStWin = CreateStatusWindow(WS_CHILD|WS_VISIBLE,"",hwnd,wId);

// Create the ListView within the main window
   hWndListView = CreateList( hwnd );
   ShowWindow(hWndListView,SW_RESTORE);	

   if ( hWndListView == NULL )
   MessageBox( NULL, "ListView not created!", NULL, MB_OK );

   ListView_SetExtendedListViewStyle(hWndListView,LVS_EX_GRIDLINES);

   

//  ImageList    ListView

   himlSmall = ImageList_Create(GetSystemMetrics(SM_CXSMICON),
	           GetSystemMetrics(SM_CYSMICON),ILC_MASK,3,1); 

//  3    ImageList

   ImageList_AddIcon(himlSmall,LoadIcon(hInst,MAKEINTRESOURCE(IDI_I)));
   ImageList_AddIcon(himlSmall,LoadIcon(hInst,MAKEINTRESOURCE(IDI_DISI)));

//  ImageList  ListView

   ListView_SetImageList(hWndListView,himlSmall,LVSIL_SMALL);

//   
   GetHomeDir();

   if(ReadMyData())
   {
      ClearFlagTaskWasRun();
	  AppendItemInListView(hwnd);

   }

  if(MyProgInfo.RunAtBoot)RunAtBoot();
  else RemoveRunAtBoot();
  if(MyProgInfo.EnableSound)AddSound();
  else RemoveSound();


  // Set Radio Button in menu
    
  if(MyProgInfo.SortByCreatedTime)CheckMenuRadioItem(GetMenu(hwnd),ID_VIEW_SORTBY_CREATEDTIME,ID_VIEW_SORTBY_STARTTIME,ID_VIEW_SORTBY_CREATEDTIME,MF_BYCOMMAND);else
	 CheckMenuRadioItem(GetMenu(hwnd),ID_VIEW_SORTBY_CREATEDTIME,ID_VIEW_SORTBY_STARTTIME,ID_VIEW_SORTBY_STARTTIME,MF_BYCOMMAND);
  
  
  //   TrayIcon  
  if(EnableAttendant)TrayMessage(hwnd,NIM_ADD,IDI_ATTENDANT,LoadIcon(hInst,MAKEINTRESOURCE(IDI_ATTENDANT)),"Attendant");
  else TrayMessage(hwnd,NIM_ADD,IDI_DISATTENDANT,LoadIcon(hInst,MAKEINTRESOURCE(IDI_DISATTENDANT)),"Attendant"); 


//  Timer

   SetTimer(hwnd,1,1000,NULL);

   return TRUE;

}



/////////////////////////////////////////////////////////////////////////////



void MainWndProc_OnSysCommand(HWND hwnd, UINT cmd, int x, int y)
{
   switch( cmd ) 
   {
      case SC_MINIMIZE:
      
	     ShowWindow(hwnd,SW_HIDE);
		       
		 if(EnableAttendant)TrayMessage(hwnd,NIM_ADD,IDI_ATTENDANT,LoadIcon(hInst,MAKEINTRESOURCE(IDI_ATTENDANT)),"Hi");
		 else TrayMessage(hwnd,NIM_ADD,IDI_DISATTENDANT,LoadIcon(hInst,MAKEINTRESOURCE(IDI_DISATTENDANT)),"Hi"); 

		 return; //        
// DefwindowProc,    TaskBar -,
//   ? :-)
	  
	  case SC_CLOSE:	
         if(!MyProgInfo.MinimizeOnClose)break;          
		 
		 ShowWindow(hwnd,SW_HIDE);
		       
		 if(EnableAttendant)TrayMessage(hwnd,NIM_ADD,IDI_ATTENDANT,LoadIcon(hInst,MAKEINTRESOURCE(IDI_ATTENDANT)),"Attendant");
		    else TrayMessage(hwnd,NIM_ADD,IDI_DISATTENDANT,LoadIcon(hInst,MAKEINTRESOURCE(IDI_DISATTENDANT)),"Attendant"); 
         return; 

   }
   FORWARD_WM_SYSCOMMAND(hwnd,cmd,x,y,DefWindowProc);

}



/////////////////////////////////////////////////////////////////////////////



void MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
   char* pEnDisStr[] = 
   {
	"&DisableAttendant",
	"&Enable Attendant"
   };

   static UINT			nIndex;
   TASK_RECORD			NewTask;
   int Idx; 

   BOOLEAN bTmpState;

   switch(id) 
   {
      case ID_ATTENDANT_EXIT:
	     SendMessage(hwnd,WM_CLOSE,NULL,NULL);

         break;
  	  case ID_VIEW_SHOWGRIDLINES:

	 	 ViewGrLine = !ViewGrLine;
		 CheckMenuItem(GetMenu(hwnd),ID_VIEW_SHOWGRIDLINES,MF_BYCOMMAND | (ViewGrLine?MF_CHECKED:MF_UNCHECKED));

		 (ViewGrLine)?ListView_SetExtendedListViewStyle(hWndListView,LVS_EX_GRIDLINES):
					  ListView_SetExtendedListViewStyle(hWndListView,0);

 	     if(ViewStBar)
		 {
           ShowWindow(hStWin,SW_HIDE);						   
  	       ShowWindow(hStWin,SW_RESTORE);						   
		 }

		 break;
 	  case ID_VIEW_SHOWSTATUSBAR:
		 (ViewStBar)?ShowWindow(hStWin,SW_HIDE):ShowWindow(hStWin,SW_RESTORE);

		 ViewStBar = ! ViewStBar;
   		 CheckMenuItem(GetMenu(hwnd),ID_VIEW_SHOWSTATUSBAR,MF_BYCOMMAND | (ViewStBar?MF_CHECKED:MF_UNCHECKED));
	     
		 break;
	  case ID_ATTENDANT_DISABLEATTENDANT:

		 //   
		 if(EnableAttendant)KillTimer(hwnd,1);
		 else SetTimer(hwnd,1,1000,NULL);

	 	 EnableAttendant = ! EnableAttendant;
		 nIndex = (nIndex == 0)?1:0;
                    
		 (nIndex == 0)?SendMessage(hwnd,WM_SETICON,ICON_SMALL,(LPARAM)LoadIcon(hInst,MAKEINTRESOURCE(IDI_ATTENDANT))):
					   SendMessage(hwnd,WM_SETICON,ICON_SMALL,(LPARAM)LoadIcon(hInst,MAKEINTRESOURCE(IDI_DISATTENDANT)));

		 ModifyMenu(GetMenu(hwnd),ID_ATTENDANT_DISABLEATTENDANT,MF_BYCOMMAND | MF_STRING,ID_ATTENDANT_DISABLEATTENDANT,pEnDisStr[nIndex]);
		 

		 break;
 	  case ID_ATTENDANT_OPTIONS:

		 DialogBox(hInst,MAKEINTRESOURCE(OPTIONDIALOG),hwnd,(DLGPROC)OptionDlgProc);
		 
		 break;

	  case ID_TASK_CREATE:
		
		  PTasks.Add(&NewTask);			  
		  NewTaskMode = TRUE;      //   
          CopyTaskMode = FALSE;

		  CurrentTaskNumber = PTasks.Size()-1;

		  DialogBox(hInst,MAKEINTRESOURCE(PROPDIALOG),hwnd,(DLGPROC)PropDlgProc);
		 
		  break;	  

	  case ID_TASK_EDIT:
		  
 
          //    
          Idx = ListView_GetNextItem(hWndListView,-1,LVNI_ALL | LVNI_SELECTED);
		  
		  if(Idx == -1) return;

		  NewTaskMode = FALSE;
		  CopyTaskMode = FALSE;


 		  CurrentTaskNumber = Idx;	
                    
          DialogBox(hInst,MAKEINTRESOURCE(PROPDIALOG),hwnd,(DLGPROC)PropDlgProc); 
		  
          
		  break;

      case ID_TASK_DELETE:

 	    //    
         Idx = ListView_GetNextItem(hWndListView,-1,LVNI_ALL | LVNI_SELECTED);
  		 if(Idx == -1) return;
 		 
	     EraseListViewItem(Idx);

		 SetCurrentDirectory(szHomeDir);
		 WriteMyData(hwnd);

         break; 

      case ID_TASK_COPY:

		 Idx = ListView_GetNextItem(hWndListView,-1,LVNI_FOCUSED);
         if(Idx == -1) return;

	     PTasks.Add(&NewTask);			  

		 CurrentTaskNumber = Idx;
	

         NewTaskMode = FALSE;
         CopyTaskMode = TRUE; 

		 DialogBox(hInst,MAKEINTRESOURCE(PROPDIALOG),hwnd,(DLGPROC)PropDlgProc); 

         break; 

      case ID_TASK_DISABLE:

   		 Idx = ListView_GetNextItem(hWndListView,-1,LVNI_ALL | LVNI_SELECTED);
         if(Idx == -1) return;
         
		 if(PTasks[Idx].DisabledTask)
         {
            MessageBox(hwnd,"Task already disabled !","Attendant",MB_OK | MB_ICONEXCLAMATION);
            return;

		 }

		 DisableCurrentTask(Idx);

		 CurrentTaskNumber = Idx;
		 ChangeListViewItem(hwnd);

		 break;

	  case POPMENU_EXIT:
		  (EnableAttendant)?TrayMessage(hwnd,NIM_DELETE,IDI_ATTENDANT,NULL,NULL):
					        TrayMessage(hwnd,NIM_DELETE,IDI_DISATTENDANT,NULL,NULL); 

	 	  SendMessage(hwnd,WM_CLOSE,0,0);
		  
		  break;
	  case POPMENU_RESTORE:
          ShowWindow(hwnd,SW_RESTORE);
	 	  		  
		  break;
	  case POPMENU_OPTIONS:
          DialogBox(hInst,MAKEINTRESOURCE(OPTIONDIALOG),hwnd,(DLGPROC)OptionDlgProc);
		  
		  break;

	  case ID_HELP_HELP:
          BOOL bResult;   // for checking boolean function result 
 
          bResult = WinHelp(hwnd, "attprj.HLP", HELP_CONTENTS, 0L); 

		  break;	  

	  case ID_HELP_ABOUT:
		  DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hwnd,(DLGPROC)AboutDlgProc);          

		  break;	  

      case ID_ATTENDANT_SAVE:
          SaveFile(hwnd,FALSE);

		  break;

      case ID_ATTENDANT_SAVEAS:
		  SaveFile(hwnd,TRUE);

		  break;

	  case ID_VIEW_ACTIVITYLOG:
		  ShowLog();

		  break;

	  case ID_VIEW_SORTBY_CREATEDTIME:
		  // Set Radio Button in menu
		  CheckMenuRadioItem(GetMenu(hwnd),ID_VIEW_SORTBY_CREATEDTIME,ID_VIEW_SORTBY_STARTTIME,ID_VIEW_SORTBY_CREATEDTIME,MF_BYCOMMAND);
          		  
		  bTmpState = EnableAttendant;

		  EnableAttendant = FALSE;
          
		  SortByCreatedTime(hwnd);

		  MyProgInfo.SortByCreatedTime = TRUE;
		  WriteMyData(hwnd);

		  EnableAttendant = bTmpState;

		  break;

	  case ID_VIEW_SORTBY_STARTTIME:
		  // Set Radio Button in menu
		  CheckMenuRadioItem(GetMenu(hwnd),ID_VIEW_SORTBY_CREATEDTIME,ID_VIEW_SORTBY_STARTTIME,ID_VIEW_SORTBY_STARTTIME,MF_BYCOMMAND);
                    
		  bTmpState = EnableAttendant;

		  EnableAttendant = FALSE;
          
		  SortByStartTime(hwnd);

		  MyProgInfo.SortByCreatedTime = FALSE;
		  WriteMyData(hwnd);

		  EnableAttendant = bTmpState;
          

		  break;


   }



   FORWARD_WM_COMMAND(hwnd,id,hwndCtl,codeNotify,DefWindowProc);
	
}



/////////////////////////////////////////////////////////////////////////////



void MainWndProc_OnDestroy(HWND hwnd)
{
   
   WinHelp(hwnd,"attprj.hlp",HELP_QUIT,0L);

   WriteMyData(hwnd);


   PostQuitMessage(0);

   FORWARD_WM_DESTROY(hwnd,DefWindowProc);
}



/////////////////////////////////////////////////////////////////////////////



void MainWndProc_OnSize(HWND hwnd,UINT state,int cx,int cy)
{
   RECT StRec;

   SendMessage(hStWin,SB_GETRECT,0,(LPARAM)&StRec);
	
   SendMessage(hStWin,WM_SIZE,cx,cy);
   BOOL B = MoveWindow(hWndListView,0,0,cx,cy-(StRec.bottom-StRec.top),TRUE);
   
   FORWARD_WM_SIZE(hwnd,state,cx,cy,DefWindowProc);
}



/////////////////////////////////////////////////////////////////////////////



void MainWndProc_OnPaint(HWND hwnd)
{
   PAINTSTRUCT		Paint;
   HDC				hDC;

   hDC = BeginPaint( hwnd, &Paint );
   EndPaint( hwnd, &Paint );

   
   FORWARD_WM_PAINT(hwnd,DefWindowProc);

}



/////////////////////////////////////////////////////////////////////////////


void MainWndProc_OnNotifyIcon(HWND hwnd,int wP, int id)
{

   POINT MyPoint;

   switch( id )
   {
     case WM_LBUTTONDOWN:

		 (EnableAttendant)?TrayMessage(hwnd,NIM_DELETE,IDI_ATTENDANT,NULL,NULL):
		                   TrayMessage(hwnd,NIM_DELETE,IDI_DISATTENDANT,NULL,NULL); 
   		 ShowWindow(hwnd,SW_RESTORE);
		 
		 break;
	 case WM_RBUTTONDOWN:	
	 	 hPopMenu = CreatePopupMenu();
		 
		 AppendMenu(hPopMenu,MF_STRING,1,"Restore");
		 AppendMenu(hPopMenu,MF_STRING,2,"Optoins");
		 AppendMenu(hPopMenu,MF_SEPARATOR ,3,"");
		 AppendMenu(hPopMenu,MF_STRING,4,"Exit");		
		 
		 GetCursorPos(&MyPoint);
		 SetForegroundWindow(hwnd);
		 TrackPopupMenu(hPopMenu,TPM_RIGHTALIGN,MyPoint.x,MyPoint.y,0,hwnd,NULL);
		 PostMessage(hwnd,0,0,0);

		 DestroyMenu(hPopMenu);
   }
   
   FORWARD_MYWM_NOTIFYICON(hwnd,wP,id,DefWindowProc); 

}



/////////////////////////////////////////////////////////////////////////////



LRESULT MainWndProc_OnNotify(HWND hwnd,int idFrom, NMHDR* pnmhdr)
{
   

   switch (pnmhdr->code)
   {

   
     case NM_DBLCLK:
        int Index; 
	    //    
        Index = ListView_GetNextItem(hWndListView,-1,LVNI_ALL | LVNI_SELECTED);
		if(Index == -1) return 0;
 		CurrentTaskNumber = Index;	
		
		DialogBox(hInst,MAKEINTRESOURCE(PROPDIALOG),hwnd,(DLGPROC)PropDlgProc);

		break;
   
     case LVN_INSERTITEM:

       //   List Item,   Status Bar
	   if(ViewStBar)
	   {       
		  ShowWindow(hStWin,SW_HIDE);						   
	      ShowWindow(hStWin,SW_RESTORE);						   
	   }

		 
        break;

     case LVN_SETDISPINFO:


	   if(ViewStBar)
	   {       
		  ShowWindow(hStWin,SW_HIDE);						   
	      ShowWindow(hStWin,SW_RESTORE);						   
	   }

		 
        break;

     case LVN_DELETEITEM:

       //   List Item,   Status Bar
	   if(ViewStBar)
	   {       
		  ShowWindow(hStWin,SW_HIDE);						   
	      ShowWindow(hStWin,SW_RESTORE);						   
	   }

		 
        break;

   }

   return FORWARD_WM_NOTIFY(hwnd,idFrom,pnmhdr,DefWindowProc);

}





/////////////////////////////////////////////////////////////////////////////



void MainWndProc_OnTimer(HWND hwnd,UINT id)
{
  
  EnterCriticalSection(&CrSec); 

  CheckDate();
  
  if(PTasks.Size() == 0) return;	

  for(int i = 0; i < PTasks.Size(); i++)
  {
    if(PTasks[i].DisabledTask) continue;
	if(PTasks[i].TaskWasRun) continue;
    
	if(PTasks[i].AtBoot && !AtBootTime) continue;
	
	if(!TimeToStart(i)) continue;
    

    PTasks[i].TaskWasRun = TRUE;

    //  

    DWORD ThreadID;    

	THREAD_RECORD		*ThreadRecord;

	ThreadRecord = new THREAD_RECORD;

	ThreadRecord->tr = PTasks[i];
    ThreadRecord->Notify = FALSE;

	
	CreateThread(NULL,0,MyThreadFunction,ThreadRecord,0,&ThreadID);
	AddRecordInLog(i);
	  
  }   


  AtBootTime = FALSE;

  LeaveCriticalSection(&CrSec); 

}



/////////////////////////////////////////////////////////////////////////////



void MainWndProc_OnMenuSelect(HWND hwnd,HMENU hmenu,int item,HMENU hmenuPopup,UINT flags)
{
  char *pMessage[] =
  {
    "Program Options",
    "You can select work mode of Attendant",
	"Save tasks list",
	"Save tasks list as ...",
	"Exit program",
	"Select visible mode for Grid Lines",
	"Select visible mode for Status Bar",
	"Sort by created time",
	"Sort by time to start",
	"Show Activity log",
	"Create new task",
	"Copy current task",
	"Edit current task",
	"Delete current task",
	"Disable current task",
	"Help",
	"About Attendant"
  };


  //   ,     
  if(hmenu == NULL){

	 SendMessage(hStWin,SB_SETTEXT,(WPARAM)0,(LPARAM)"");
  }
  
  
  if (hmenuPopup == 0L) 
  {

    if((item < 40001) || (item > 40015))return;
    if (!(flags & MF_SYSMENU)) 
	{    
	  if(flags & MF_SEPARATOR)return;
	  SendMessage(hStWin,SB_SETTEXT,(WPARAM)0,(LPARAM)pMessage[item-40001]);
	}
    
  }

 

	
  FORWARD_WM_MENUSELECT(hwnd,hmenu,item,hmenuPopup,flags,DefWindowProc);
}



/////////////////////////////////////////////////////////////////////////////



LONG APIENTRY MainWndProc( HWND hWnd, UINT msg, UINT wParam, LONG lParam) 
{

   switch ( msg ) 
   {
	  HANDLE_MSG(hWnd,WM_CREATE,MainWndProc_OnCreate);	     
	  HANDLE_MSG(hWnd,WM_SYSCOMMAND,MainWndProc_OnSysCommand);	     
	  HANDLE_MSG(hWnd,WM_COMMAND,MainWndProc_OnCommand);	     	
	  HANDLE_MSG(hWnd,WM_DESTROY,MainWndProc_OnDestroy);	     
	  HANDLE_MSG(hWnd,WM_PAINT,MainWndProc_OnPaint);	     
	  HANDLE_MSG(hWnd,WM_SIZE,MainWndProc_OnSize);	     
      HANDLE_MSG(hWnd,WM_NOTIFY,MainWndProc_OnNotify);
	  HANDLE_MSG(hWnd,WM_TIMER,MainWndProc_OnTimer);
	  HANDLE_MSG(hWnd,WM_MENUSELECT,MainWndProc_OnMenuSelect);

	  HANDLE_MSG(hWnd,MYWM_NOTIFYICON,MainWndProc_OnNotifyIcon);	     

	  default:
	     return(DefWindowProc(hWnd,msg,wParam,lParam));
   }


}


/////////////////////////////////////////////////////////////////////////////


BOOL InitApplication( HANDLE hInstance )
{
	WNDCLASS  wc;
	
	// Fill in window class structure with parameters that describe the
	// main (statistics) window. 
	wc.style			= 0;                     
	wc.lpfnWndProc		= (WNDPROC)MainWndProc; 
	wc.cbClsExtra		= 0;              
	wc.cbWndExtra		= 0;              
	wc.hInstance		= (HINSTANCE)hInstance;       
	wc.hIcon			= LoadIcon((HINSTANCE)hInstance,MAKEINTRESOURCE(IDI_ATTENDANT));
	wc.hCursor			= LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground	= (HBRUSH)GetStockObject( LTGRAY_BRUSH ); 
	wc.lpszMenuName		= MAKEINTRESOURCE(MAINMENU);  
	wc.lpszClassName	= "AttendantClass";
	if ( ! RegisterClass( &wc ) )
		return FALSE;
	
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////



HWND InitInstance( HANDLE hInstance, int nCmdShow )
{
	HWND hWndMain;

	hInst = (HINSTANCE)hInstance;

    Get_Position_Settings();

	hWndMain = CreateWindow( "AttendantClass", "Attendant", 
							WS_OVERLAPPEDWINDOW,
							PosInfo.left, PosInfo.top, 
							PosInfo.width, PosInfo.height,
							NULL, NULL, (HINSTANCE)hInstance, NULL );

	// if window could not be created, return "failure" 
	if ( ! hWndMain )
		return NULL;
	
	// make the window visible; update its client area; and return "success"
//	ShowWindow( hWndMain, nCmdShow );
//	UpdateWindow( hWndMain ); 
	return hWndMain;      
}



/////////////////////////////////////////////////////////////////////////////



int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpCmdLine, int nCmdShow )
{
	MSG 	msg;      
	HACCEL	hAccel;
 	DWORD	Version;
	HWND hWnd;


	//  ?

	hWnd = FindWindow("AttendantClass",g_szAppName);
	if(hWnd)
	{
		//    - 
		if(IsIconic(hWnd))ShowWindow(hWnd,SW_RESTORE);

		//     
		SetForegroundWindow(hWnd);
		//MessageBox(NULL,"Ops","Attendant",MB_OK); 
		return FALSE;
	}



    InitializeCriticalSection(&CrSec);

	
	if ( ! InitApplication( hInstance ) )
		return FALSE;   
	
	// get NT version
	Version = GetVersion();
	if( Version < 0x80000000 ) {
		MessageBox( NULL, "Not running on Windows 95.",
			"Attendant", MB_OK|MB_ICONERROR );
		return TRUE;
	}  

	// initializations that apply to a specific instance 
	if ( (hWnd = InitInstance( hInstance, nCmdShow )) == NULL )
		return FALSE;



	// load accelerators
	hAccel = LoadAccelerators( hInstance, TEXT("ACCELERATORS"));


	// acquire and dispatch messages until a WM_QUIT message is received.
	while ( GetMessage( &msg, NULL, 0, 0 ) )  {
		if( !TranslateAccelerator( hWnd, hAccel, &msg )) {
		
			TranslateMessage( &msg );
			DispatchMessage( &msg ); 
		}
	}

	DeleteCriticalSection(&CrSec);

	return msg.wParam;										 
}



////////////////// End Of File /////////////////////////////////////