#include <windows.h>    // includes basic windows functionality
#include <windowsx.h>
#include <commctrl.h>   // includes the common control header
#include <stdio.h>
#include <string.h>
#include <windef.h>

#include "resource.h"
#include "..\CmnHdr.h"
#include "..\array.h"
#include "GlobDef.h"

#define ID_SPIN 999



void SetVisibleState(HWND hwnd,int Freq);
BOOL StoredUserSettings(HWND hwnd);
void LoadTask(HWND hwnd);
void CreateNewListViewItem(HWND hwnd);
void ChangeListViewItem(HWND hwnd);
void EraseListViewItem(int Index);
void DisableCurrentTask(int Idx);
HICON IconExtract(char* FileName,int Id);
void  GetHomeDir();

// Extern Global variable from Main.cpp

extern HINSTANCE	hInst;
extern ARRAY<TASK_RECORD> PTasks;
extern HWND		  hPropDlg;
extern HWND		  hWndListView;
extern UINT		  CurrentTaskNumber; 
extern BOOLEAN	  NewTaskMode;
extern HIMAGELIST himlSmall;  
extern char		  szHomeDir[512];	
extern PROG_INFO  MyProgInfo;
extern POSITION_SETTINGS	PosInfo;

//-------------------------------------

HWND hSpinWnd; // Handle of Spin



////////////////////////////////////////////////////////////////////////



void InitPropDialog(HWND hwnd, int TaskType)
{

   SYSTEMTIME st;

   static HWND hListBox;
   
   LPSTR pszItems[7]={"Sunday","Monday","Tuesday","Wednesday",
		               "Thursday","Friday","Saturday"};


// draw exclamation on button
   Button_SetText(GetDlgItem(hwnd,IDC_OPEN_BTN),"!");

//  ListBox
   hListBox = GetDlgItem(hwnd,IDC_WEEKDAYS_LB);
   for(int i=0;i < 7;i++)
	   SendMessage(hListBox,LB_ADDSTRING,(WPARAM)0,(LPARAM)pszItems[i]);

//    -   Edit

   SendDlgItemMessage(hwnd,IDC_TIME_ED,EM_SETLIMITTEXT,5,0);
   SendDlgItemMessage(hwnd,IDC_EDIT_ED,EM_SETLIMITTEXT,510,0);
   SendDlgItemMessage(hwnd,IDC_DATE_ED,EM_SETLIMITTEXT,8,0);
   SendDlgItemMessage(hwnd,IDC_DAY_ED,EM_SETLIMITTEXT,2,0);


//   
   GetLocalTime(&st);
   
   TCHAR TimeString[8];
   WORD y;
   
   wsprintf(TimeString,TEXT("%02d:%02d"),st.wHour,st.wMinute);
   SetWindowText(GetDlgItem(hwnd,IDC_TIME_ED),TimeString);

   y = st.wYear % 100; // ,  2   ;)
   
   wsprintf(TimeString,TEXT("%02d.%02d.%02d"),st.wDay,st.wMonth,y);
   SetWindowText(GetDlgItem(hwnd,IDC_DATE_ED),TimeString);


   if(NewTaskMode) 
   {
     // Look at the second parameter of this function    
     if(TaskType)
	 {        
		SendDlgItemMessage(hwnd,IDC_PROG_RB,BM_SETCHECK,BST_CHECKED,0);
        Button_Enable(GetDlgItem(hwnd,IDC_OPEN_BTN),FALSE);
     } else
     {
        SendDlgItemMessage(hwnd,IDC_MSG_RB,BM_SETCHECK,BST_CHECKED,0);
        Button_Enable(GetDlgItem(hwnd,IDC_OPEN_BTN),FALSE);

     }   

     //     " "
     SendDlgItemMessage(hwnd,IDC_ONETIME_RB,BM_SETCHECK,BST_CHECKED,0);
     SetVisibleState(hwnd,0);


     //  RB Time  -  
     SendDlgItemMessage(hwnd,IDC_TIME_RB,BM_SETCHECK,BST_CHECKED,0);

   }

   return;

}



////////////////////////////////////////////////////////////////////////



void SetVisibleState(HWND hwnd,int Freq)
{
  
  switch (Freq )
  { 
	 case 0: // OneTime 
       ShowWindow(GetDlgItem(hwnd,IDC_WEEKDAYS_LB),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DAY_ED),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DAY_ST),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DATE_ED),SW_RESTORE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DATE_ST),SW_RESTORE);

	   break;	 
     case 1: // Weekly
       ShowWindow(GetDlgItem(hwnd,IDC_WEEKDAYS_LB),SW_RESTORE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DAY_ED),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DATE_ED),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DAY_ST),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DATE_ST),SW_HIDE);

	   break;
     case 2: // Monthly
       ShowWindow(GetDlgItem(hwnd,IDC_WEEKDAYS_LB),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DAY_ED),SW_RESTORE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DAY_ST),SW_RESTORE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DATE_ED),SW_HIDE);
	   ShowWindow(GetDlgItem(hwnd,IDC_DATE_ST),SW_HIDE);

     break;
  };
	    

   return;

} 




////////////////////////////////////////////////////////////////////////

void MyError(HWND hwnd,char* MyText)
{
  MessageBox(hwnd,MyText,"Attendant",MB_ICONERROR | MB_OK);
}


////////////////////////////////////////////////////////////////////////


// -      
BOOL StoredUserSettings(HWND hwnd)
{
  char MyText[512] = "";


//    
  char chTime[6];
  char *d;
  int i,Length,iHour,iMin;

  char buf[2]; 
  int iMax = 3,iDay;
  char chDate[9];
  int D,M,Y;

  BOOL AtBoot;
  int Freq;
  int DaysOfWeek[7];

  AtBoot = Button_GetCheck(GetDlgItem(hwnd,IDC_ATBOOT_RB));

  if(!AtBoot)
  {
     GetWindowText(GetDlgItem(hwnd,IDC_TIME_ED),chTime,6);
     d = strchr(chTime,':');
     i = d - chTime;
  
     if(d == NULL)              //  ? Go out !
	 { MyError(hwnd,"Invalid Time"); 
       return FALSE;
	 }
     Length = strlen(chTime);

 	 if(i == 0)                 // ':' 1- ?  Go Out !  
	 { 
	   MyError(hwnd,"Invalid Time"); 
       return FALSE;
	 }

     if((i+1) == Length)	 // ':'  ?  Go Out !    
	 { MyError(hwnd,"Invalid Time"); 
       return FALSE;
	 }

     sscanf(chTime,"%2d:%2d",&iHour,&iMin);

  
     if(iHour > 23)
	 {
       MyError(hwnd,"Invalid hour");
	   return FALSE;
	 }

     if(iMin > 59)
	 {
       MyError(hwnd,"Invalid minute");
	   return FALSE;
	 }

  }

//  
  if(Button_GetCheck(GetDlgItem(hwnd,IDC_ONETIME_RB)))Freq = 0;
  if(Button_GetCheck(GetDlgItem(hwnd,IDC_DAILY_RB)))Freq = 1;
  if(Button_GetCheck(GetDlgItem(hwnd,IDC_MONTHLY_RB)))Freq = 2;



//    

  if(Freq == 0)
  {

  
     GetWindowText(GetDlgItem(hwnd,IDC_DATE_ED),chDate,9);
     d = strchr(chDate,'.');
  
     if(d == NULL) //  ?
	 {
	   MyError(hwnd,"Invalid Date");
	   return FALSE;
	 }
  
     i = d - chDate;

     if(i == 0) //  1- ?
	 {
	    MyError(hwnd,"Invalid Date");
	    return FALSE;
	 }

     Length = strlen(chDate);
     if(Length < 5) //   5 ?
	 {
	   MyError(hwnd,"Invalid Date");
	   return FALSE;
	 }
 

     sscanf(chDate,"%2d.%2d.%2d",&D,&M,&Y);

     if(D > 31 || D < 1)
	 { MyError(hwnd,"Invalid Day");
       return FALSE;
	 }

     if(M > 12 || M < 1)
	 { MyError(hwnd,"Invalid Month");
       return FALSE;
	 }
  
     if(D > 99 || D < 0)
	 { MyError(hwnd,"Invalid Year");
       return FALSE;
	 }

  }


//   


  if(Freq == 2)
  {
     Edit_GetText(GetDlgItem(hwnd,IDC_DAY_ED),buf,iMax);
     iDay = atoi(buf);
	 if(iDay < 1 || iDay > 31)
     {
        MyError(hwnd,"Not valid day of month");
		return FALSE;
	 }
		 
  }



//    

  if(Freq == 1)
  {	  
     FillMemory(DaysOfWeek,7*sizeof(int),8);
     ListBox_GetSelItems(GetDlgItem(hwnd,IDC_WEEKDAYS_LB),7,DaysOfWeek);
	 if(DaysOfWeek[0] > 6)
	 {
	   MyError(hwnd,"Select day of week, please.");
	   return FALSE;	   
     }
  }

  for(int k = 0; k < 7; k++) 
  {
    PTasks[CurrentTaskNumber].DaysOfWeek[k] = DaysOfWeek[k];
  }

  if(Freq == 0)
  {
    
//  

    SYSTEMTIME	st;
    int			j;


    GetLocalTime(&st);
	j = st.wYear % 100;
	j = st.wYear - j;
	Y += j;
	  
    PTasks[CurrentTaskNumber].StartTime.wYear = Y; 
    PTasks[CurrentTaskNumber].StartTime.wMonth = M;
    PTasks[CurrentTaskNumber].StartTime.wDay = D;
  }

  if(Freq == 2)
  {
    PTasks[CurrentTaskNumber].DayOfMonth = atoi(buf);
  }

   if(!AtBoot)
  {
    PTasks[CurrentTaskNumber].StartTime.wHour = iHour;
    PTasks[CurrentTaskNumber].StartTime.wMinute = iMin;
  }



//       ?
  PTasks[CurrentTaskNumber].AtBoot = AtBoot;


//      
  GetLocalTime(&PTasks[CurrentTaskNumber].BeginTime);
  
//    <>?
  if Button_GetCheck(GetDlgItem(hwnd,IDC_MSG_RB))
  {
    GetWindowText(GetDlgItem(hwnd,IDC_EDIT_ED),MyText,512);
    strcpy(PTasks[CurrentTaskNumber].szText, MyText); 
    PTasks[CurrentTaskNumber].TaskType = 0;

  } else 
  {
    GetWindowText(GetDlgItem(hwnd,IDC_EDIT_ED),MyText,512);
    strcpy(PTasks[CurrentTaskNumber].szFileName, MyText); 
	PTasks[CurrentTaskNumber].TaskType = 1;
  };

//    
  PTasks[CurrentTaskNumber].DisabledTask = Button_GetCheck(GetDlgItem(hwnd,IDC_DISTASK));
  PTasks[CurrentTaskNumber].TaskWasRun = 0;

//  
  PTasks[CurrentTaskNumber].Freq = Freq;  

  return TRUE;

}


////////////////////////////////////////////////////////////////////////

//     

void LoadTask(HWND hwnd)
{

  TCHAR		DateString[9]; 
  TCHAR		TimeString[6]; 
  int		Y;
  char buf[2];
  int i = 2;



//   
  if(PTasks[CurrentTaskNumber].TaskType)Edit_SetText(GetDlgItem(hwnd,IDC_EDIT_ED),PTasks[CurrentTaskNumber].szFileName); 
  else Edit_SetText(GetDlgItem(hwnd,IDC_EDIT_ED),PTasks[CurrentTaskNumber].szText); 


//         

  if(PTasks[CurrentTaskNumber].TaskType)
  {
     SendDlgItemMessage(hwnd,IDC_PROG_RB,BM_SETCHECK,BST_CHECKED,0);
     Button_Enable(GetDlgItem(hwnd,IDC_OPEN_BTN),TRUE);
  }else
  {
     SendDlgItemMessage(hwnd,IDC_MSG_RB,BM_SETCHECK,BST_CHECKED,0);
     Button_Enable(GetDlgItem(hwnd,IDC_OPEN_BTN),FALSE);   
  }

 
//   Radio button

  if(PTasks[CurrentTaskNumber].Freq == 0)SendDlgItemMessage(hwnd,IDC_ONETIME_RB,BM_SETCHECK,BST_CHECKED,0);
  if(PTasks[CurrentTaskNumber].Freq == 1)SendDlgItemMessage(hwnd,IDC_DAILY_RB,BM_SETCHECK,BST_CHECKED,0);
  if(PTasks[CurrentTaskNumber].Freq == 2)SendDlgItemMessage(hwnd,IDC_MONTHLY_RB,BM_SETCHECK,BST_CHECKED,0);	

//  - Disable

  Button_SetCheck(GetDlgItem(hwnd,IDC_DISTASK),PTasks[CurrentTaskNumber].DisabledTask);


//  ,   

  SetVisibleState(hwnd,PTasks[CurrentTaskNumber].Freq);


//   AtBoot   

  if(PTasks[CurrentTaskNumber].AtBoot)
  {
 	 EnableWindow(GetDlgItem(hwnd,IDC_TIME_ED),FALSE);

	 // ???
	 //	 EnableWindow(GetDlgItem(hwnd,ID_SPIN),FALSE);

     Button_SetCheck(GetDlgItem(hwnd,IDC_ATBOOT_RB),TRUE);

  } else
  {

//  
  
     Button_SetCheck(GetDlgItem(hwnd,IDC_TIME_RB),TRUE); 
  	 EnableWindow(GetDlgItem(hwnd,IDC_TIME_ED),TRUE);


	 wsprintf(TimeString,TEXT("%02d:%02d"),PTasks[CurrentTaskNumber].StartTime.wHour,
       	      PTasks[CurrentTaskNumber].StartTime.wMinute);
     SetWindowText(GetDlgItem(hwnd,IDC_TIME_ED),TimeString);

  }



//  .     = 0 
  if(PTasks[CurrentTaskNumber].Freq == 0) 
  { 
     
     Y = PTasks[CurrentTaskNumber].StartTime.wYear % 100;
     
	 wsprintf(DateString,TEXT("%02d.%02d.%02d"),PTasks[CurrentTaskNumber].StartTime.wDay,
        	  PTasks[CurrentTaskNumber].StartTime.wMonth,Y);
	 
     SetWindowText(GetDlgItem(hwnd,IDC_DATE_ED),DateString);
	 
  }
  

//   

  if(PTasks[CurrentTaskNumber].Freq == 1) 
  { 

	for(i = 0;i < 7;i++)
	{
      if(PTasks[CurrentTaskNumber].DaysOfWeek[i] > 6) break; 
	  SendMessage(GetDlgItem(hwnd,IDC_WEEKDAYS_LB),LB_SETSEL,(WPARAM)TRUE,(LPARAM)PTasks[CurrentTaskNumber].DaysOfWeek[i]);
	}	

  }

//   

  if(PTasks[CurrentTaskNumber].Freq == 2) 
    	 
	  // ??? !!! ???
	  Edit_SetText(GetDlgItem(hwnd,IDC_DAY_ED),itoa(PTasks[CurrentTaskNumber].DayOfMonth,buf,10));


}



////////////////////////////////////////////////////////////////////////


void CorrectListViewItem(HWND hwnd)
{
//   ListView_SetItemText 
//   ListViewItem
    

}




////////////////////////////////////////////////////////////////////////



void ChangeSubItems()
{

  //   SubItems

   char szDateStr[11];
   char szTimeStr[5];
   char szDays[255] = "Every ";
   char szDayOfMonth[255] = "Every ";

   int i;

   switch(PTasks[CurrentTaskNumber].Freq)
   {
	  case 0:
        wsprintf(szDateStr,"%02d.%02d.%02d",
		  PTasks[CurrentTaskNumber].StartTime.wYear,
		  PTasks[CurrentTaskNumber].StartTime.wMonth,
		  PTasks[CurrentTaskNumber].StartTime.wDay);
	 

		ListView_SetItemText(hWndListView,CurrentTaskNumber,1,szDateStr);

	    break;
	  case 1:
        for(i = 0;i < 7;i++)
        {
          if(PTasks[CurrentTaskNumber].DaysOfWeek[i] > 6)break; 
		  
		  switch(PTasks[CurrentTaskNumber].DaysOfWeek[i])
          {
		     case 0:
               strcat(szDays,"Sunday,");
			   break;
		     case 1:
               strcat(szDays,"Monday,");
			   break;
		     case 2:
               strcat(szDays,"Tuesday,");
			   break;
		     case 3:
               strcat(szDays,"Wednesday,");
			   break;
		     case 4:
               strcat(szDays,"Thursay,");
			   break;
		     case 5:
               strcat(szDays,"Friday,");
			   break;
		     case 6:
               strcat(szDays,"Saturday,");
			   break;

          }
		
        }

		if(szDays[strlen(szDays)-1] == ',')szDays[strlen(szDays)-1] = ' ';   
		
        ListView_SetItemText(hWndListView,CurrentTaskNumber,1,szDays); 

		break;

	  case 2:

        char buf[2];

        strcat(szDayOfMonth,itoa(PTasks[CurrentTaskNumber].DayOfMonth,buf,10));
        strcat(szDayOfMonth," day of month");

        ListView_SetItemText(hWndListView,CurrentTaskNumber,1,szDayOfMonth); 

	    break;


	}

   if(!PTasks[CurrentTaskNumber].AtBoot)
   {   
	  wsprintf(szTimeStr,"%02d:%02d",PTasks[CurrentTaskNumber].StartTime.wHour,
            PTasks[CurrentTaskNumber].StartTime.wMinute);
      ListView_SetItemText(hWndListView,CurrentTaskNumber,2,szTimeStr); 
   } else
   {
      ListView_SetItemText(hWndListView,CurrentTaskNumber,2,"At Boot"); 

   }


}



////////////////////////////////////////////////////////////////////////



void CreateNewListViewItem(HWND hwnd)
{
    LV_ITEM		pitem;
    char		chText[512],chBuf[512];

    if(PTasks[CurrentTaskNumber].TaskType) strcpy(chText,PTasks[CurrentTaskNumber].szFileName);
	else strcpy(chText,PTasks[CurrentTaskNumber].szText);

    strcpy(chBuf,chText);

//    LV_ITEM

	pitem.mask = LVIF_TEXT | LVIF_IMAGE;
	pitem.iItem = CurrentTaskNumber;
    pitem.iSubItem = 0;
	pitem.cchTextMax = 40;
    
	pitem.pszText = chText;
	
	if(!PTasks[CurrentTaskNumber].TaskType)
    {
      if(PTasks[CurrentTaskNumber].DisabledTask)pitem.iImage = 1;
	  else pitem.iImage = 0;

    }
    else
    {
  	  HICON hi;
	  hi = IconExtract(chBuf,0);
	  if(hi)
	  { ImageList_AddIcon(himlSmall,hi);
	    pitem.iImage = ImageList_GetImageCount(himlSmall) - 1;
         
	  }
    } 
		   
		

	ListView_InsertItem(hWndListView,&pitem);

    pitem.iSubItem = 1;
	ListView_InsertItem(hWndListView,&pitem);


	ChangeSubItems();

}



////////////////////////////////////////////////////////////////////////



void ChangeListViewItem(HWND hwnd)
{
  LV_ITEM li;

  if(!PTasks[CurrentTaskNumber].TaskType) 
  {
    li.iItem = CurrentTaskNumber;
	li.mask = LVIF_TEXT | LVIF_IMAGE;
	li.iSubItem = 0;
	li.cchTextMax = 40;
    
	if(PTasks[CurrentTaskNumber].DisabledTask)li.iImage = 1;
	else li.iImage = 0;

    ListView_SetItem(hWndListView,&li);    
	
  }

  if(PTasks[CurrentTaskNumber].TaskType)
	 ListView_SetItemText(hWndListView,CurrentTaskNumber,0,PTasks[CurrentTaskNumber].szFileName)
  else
     ListView_SetItemText(hWndListView,CurrentTaskNumber,0,PTasks[CurrentTaskNumber].szText);

  ChangeSubItems();
  
  return;

}



////////////////////////////////////////////////////////////////////////



void EraseListViewItem(int Index)
{

  
//    ListItem

  BOOL B = ListView_DeleteItem(hWndListView,Index);
  
  
  PTasks.Delete(Index);
  

//     Image  ListImage

}



////////////////////////////////////////////////////////////////////////



void DisableCurrentTask(int Idx)
{

  PTasks[Idx].DisabledTask = TRUE;

}



////////////////////////////////////////////////////////////////////////


HICON IconExtract(char* FileName,int Id)
{
  HICON		IconHandle;
  WORD		Index;

  IconHandle = ExtractIcon(hInst,FileName,Id);
  if((int)IconHandle < 2)
  {
    Index = Id;
	IconHandle = ExtractAssociatedIcon(hInst,FileName,&Index);
  }

  if((int)IconHandle < 2) return NULL;

  return IconHandle; 
   

}



////////////////////////////////////////////////////////////////////////



void WriteMyData(HWND hwnd)
{

  char szMyDatFile[512] = "";
  HANDLE hF;
  UINT i;
  RECT r;

  strcat(szMyDatFile,szHomeDir);
  strcat(szMyDatFile,"\\attend.dat");

  SetCurrentDirectory(szHomeDir);


  hF = CreateFile(szMyDatFile,GENERIC_WRITE,FILE_SHARE_READ,
			              NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);  


  WriteFile(hF,&MyProgInfo,sizeof(PROG_INFO),(unsigned long *)&i,NULL); 
  
// Get position of the main window

  GetWindowRect(hwnd,&r);
  PosInfo.left		= r.left;
  PosInfo.top		= r.top;
  PosInfo.width		= r.right - r.left;
  PosInfo.height	= r.bottom - r.top;

  
  WriteFile(hF,&PosInfo,sizeof(POSITION_SETTINGS),(unsigned long *)&i,NULL); 
  
  int j = PTasks.Size();

  WriteFile(hF,&j,sizeof(int),(unsigned long *)&i,NULL); 

  WriteFile(hF,&PTasks[0],sizeof(TASK_RECORD)*PTasks.Size(),(unsigned long *)&i,NULL); 

  CloseHandle(hF);

}



////////////////////////////////////////////////////////////////////////


BOOL ReadMainWindowSettings()
{
  HANDLE			hF,fF;
  char szMyDatFile[512] = "";
  WIN32_FIND_DATA	fd;
  UINT				i;

  GetHomeDir();

  SetCurrentDirectory(szHomeDir);

//    
  strcat(szMyDatFile,szHomeDir);
  strcat(szMyDatFile,"\\attend.dat");

//    ?
  fF = FindFirstFile(szMyDatFile,&fd);

//  -   
  if(fF == INVALID_HANDLE_VALUE) return FALSE;

  FindClose(fF);

//  
  hF = CreateFile(szMyDatFile,GENERIC_READ,FILE_SHARE_READ,
			              NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);  

//  
  ReadFile(hF,&MyProgInfo,sizeof(PROG_INFO),(unsigned long *)&i,NULL);
  ReadFile(hF,&PosInfo,sizeof(POSITION_SETTINGS),(unsigned long *)&i,NULL);

//  
  CloseHandle(hF);


  return TRUE;
}


////////////////////////////////////////////////////////////////////////



BOOL ReadMyData()
{

  char szMyDatFile[512] = "";
  HANDLE			hF,fF;
  UINT				i,j;
  TASK_RECORD		tr;
  WIN32_FIND_DATA	fd;

  SetCurrentDirectory(szHomeDir);

//    
  strcat(szMyDatFile,szHomeDir);
  strcat(szMyDatFile,"\\attend.dat");

//    ?
  fF = FindFirstFile(szMyDatFile,&fd);

//  -   
  if(fF == INVALID_HANDLE_VALUE) return FALSE;

  FindClose(fF);

//  
  hF = CreateFile(szMyDatFile,GENERIC_READ,FILE_SHARE_READ,
			              NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);  

//  
  ReadFile(hF,&MyProgInfo,sizeof(PROG_INFO),(unsigned long *)&i,NULL);

//    
  ReadFile(hF,&PosInfo,sizeof(POSITION_SETTINGS),(unsigned long *)&i,NULL);

//   
  ReadFile(hF,&j,sizeof(int),(unsigned long *)&i,NULL);

//   -  .
  if(j == 0)
  {
    CloseHandle(hF);
    return FALSE;
  }

//    
  for(i = 0;i != j; i++)
  {
    PTasks.Add(&tr);	  

  }

//        
  ReadFile(hF,&PTasks[0],sizeof(TASK_RECORD)*PTasks.Size(),(unsigned long *)&i,NULL);

//  
  CloseHandle(hF);

  return TRUE;


}



////////////////////////////////////////////////////////////////////////



void AppendItemInListView(HWND hwnd)
{
  int	i;

  if(PTasks.Size() == 0) return;

  for(i = 0; i < PTasks.Size(); i++)
  {
      CurrentTaskNumber = i;
	  CreateNewListViewItem(hwnd);     	  

  }

}




////////////////////////////////////////////////////////////////////////



void ClearFlagTaskWasRun()
{
   for(int i = 0; i < PTasks.Size(); i++)
   {
     PTasks[i].TaskWasRun = FALSE;

   }   

}



////////////////////////////////////////////////////////////////////////
