#include <windows.h>
#include <commctrl.h>   // includes the common control header
#include "..\array.h"
#include "GlobDef.h"

extern ARRAY<TASK_RECORD> PTasks;            // Task List
extern HWND				  hWndListView;      // Handle of the ListView
extern UINT				  CurrentTaskNumber; //   


ARRAY<TASK_RECORD>        PTmpTasks;         // Temp Task List


void CreateNewListViewItem(HWND hwnd);
void SortByStartTime(HWND hwnd);
void SortByCreatedTime(HWND hwnd);


void SortByStartTime(HWND hwnd)
{
  TASK_RECORD tr;
	
  // At first move the tasks with AtBoot = TRUE
  int iCount = 0;

  iCount = PTasks.Size();

  if(iCount <= 1) return; //  

  for(int i = iCount-1; i >= 0; i--){

	  if(PTasks[i].AtBoot){
		 tr = PTasks[i];
		 PTmpTasks.Add(&tr);
		 
		 PTasks.Delete(i); 

	  }

  }	  

  // Sort by Time
  SYSTEMTIME st; // Here is an most early time
  int iDelIndex = -1; // Index of Item with most early time
  


  while(PTasks.Size() > 0){ // while count of task more then one

	  iCount = PTasks.Size();
	  st = PTasks[0].StartTime; // Suppose that task N 0 the most early task
	  
	  iDelIndex = 0; 

	  for(i=1; i < iCount; i++){
		  if(PTasks[i].StartTime.wHour > st.wHour)continue; // Obviously
		  
		  if((PTasks[i].StartTime.wHour == st.wHour)&&			  
		     (PTasks[i].StartTime.wMinute >= st.wMinute))continue; 

		  st = PTasks[i].StartTime; // stored new most early time
		  iDelIndex = i;			// stored index of most early task

	  }
	  tr = PTasks[iDelIndex];
	  PTmpTasks.Add(&tr);
       
	  PTasks.Delete(iDelIndex);
	  

  }

  if(PTmpTasks.Size() < 1)return; // 

  iCount = PTmpTasks.Size();

  for(i=0; i < iCount; i++){

	  tr = PTmpTasks[i];
	  PTasks.Add(&tr);

  }

  PTmpTasks.DeleteAll();


  ListView_DeleteAllItems(hWndListView);

  for(i=0; i < iCount; i++){
	  CurrentTaskNumber = i;
      CreateNewListViewItem(hwnd);     


  }


}


void SortByCreatedTime(HWND hwnd)
{

  SYSTEMTIME st;
  int iCount = 0,iDelIndex = 0;
  TASK_RECORD tr;

  if(PTasks.Size() <= 1)return; //  


  while(PTasks.Size() > 0){ // while count of task more then one

	  iCount = PTasks.Size();
	  st = PTasks[0].BeginTime; // Suppose that task N 0 the most early task
	  
	  iDelIndex = 0; 

	  for(int i=1; i < iCount; i++){
		  if(PTasks[i].BeginTime.wHour > st.wHour)continue; // Obviously
		  
		  if((PTasks[i].BeginTime.wHour == st.wHour)&&
 		     (PTasks[i].BeginTime.wMinute > st.wMinute))continue; 
          
		  if((PTasks[i].BeginTime.wHour == st.wHour)&&
 		     (PTasks[i].BeginTime.wMinute == st.wMinute)&&			  
			 (PTasks[i].BeginTime.wSecond >= st.wSecond))continue;

		  st = PTasks[i].BeginTime; // stored new most early time
		  iDelIndex = i;			// stored index of most early task

	  }
	  tr = PTasks[iDelIndex];
	  PTmpTasks.Add(&tr);
       
	  PTasks.Delete(iDelIndex);
	  

  }


  if(PTmpTasks.Size() < 1)return; // 

  iCount = PTmpTasks.Size();

  for(int i=0; i < iCount; i++){

	  tr = PTmpTasks[i];
	  PTasks.Add(&tr);

  }

  PTmpTasks.DeleteAll();


  ListView_DeleteAllItems(hWndListView);

  for(i=0; i < iCount; i++){
	  CurrentTaskNumber = i;
      CreateNewListViewItem(hwnd);     


  }




}