#include <windows.h>    // includes basic windows functionality
#include <winuser.h>
#include <mmsystem.h>

#include "..\array.h" // Was created by Jury Shvetsov
#include "GlobDef.h"


DWORD WINAPI MyThreadFunction(LPVOID lpPar);
void ClearFlagTaskWasRun();
void CheckDate();

extern ARRAY<TASK_RECORD> PTasks;
extern BOOLEAN	  		  AtBootTime;
extern THREAD_RECORD	  *ThreadRecord;
extern CRITICAL_SECTION   CrSec; 

extern SYSTEMTIME         CurrentDate;

////////////////////////////////////////////////////////////////////////



BOOL WeWereLate(int TN)
{
  SYSTEMTIME	st;
  int			j;

  GetLocalTime(&st);  

  switch(PTasks[TN].Freq)
  {
    case 0:
      	  
      if(PTasks[TN].StartTime.wYear < st.wYear)return TRUE;
	  if(PTasks[TN].StartTime.wYear == st.wYear &&
		 PTasks[TN].StartTime.wMonth < st.wMonth) return TRUE;
	  if(PTasks[TN].StartTime.wDay < st.wDay && 
		 PTasks[TN].StartTime.wMonth == st.wMonth)return TRUE;
	  if(PTasks[TN].StartTime.wDay == st.wDay && 
         PTasks[TN].StartTime.wHour < st.wHour)return TRUE;
	  if(PTasks[TN].StartTime.wHour == st.wHour && 
         PTasks[TN].StartTime.wMinute < st.wMinute)return TRUE;

	break;

	case 1:
	  j = 0;
Begin:
      if(PTasks[TN].DaysOfWeek[j] > 6)break;
  	  if(PTasks[TN].DaysOfWeek[j] == st.wDayOfWeek)
		{
	
	 	  if(PTasks[TN].StartTime.wHour < st.wHour)return TRUE; 
		  if(PTasks[TN].StartTime.wHour == st.wHour	&& 
			 PTasks[TN].StartTime.wMinute < st.wMinute)return TRUE;
			  
		}
	  
	  j++;
	  if(j < 7) goto Begin;



	break;

	case 2:
      if(PTasks[TN].DayOfMonth == st.wDay)
      {
        if(PTasks[TN].StartTime.wHour < st.wHour)return TRUE;
		if(PTasks[TN].StartTime.wHour == st.wHour &&
           PTasks[TN].StartTime.wMinute < st.wMinute)return TRUE;
	  }

	break;

  }

  return FALSE;
}


////////////////////////////////////////////////////////////////////////



BOOL TimeToStart(int i)
{
  SYSTEMTIME	st; 
  int			j = 0;
  

  GetLocalTime(&st);

  switch(PTasks[i].Freq)
  {
	case 0:
      if(PTasks[i].AtBoot && AtBootTime)
      {
        if(PTasks[i].StartTime.wDay == st.wDay && 
		   PTasks[i].StartTime.wMonth == st.wMonth && 
		   PTasks[i].StartTime.wYear == st.wYear) return TRUE;
      }
         if(PTasks[i].StartTime.wDay == st.wDay && 
			PTasks[i].StartTime.wMonth == st.wMonth &&
			PTasks[i].StartTime.wYear == st.wYear &&
			PTasks[i].StartTime.wHour == st.wHour &&
			PTasks[i].StartTime.wMinute == st.wMinute) return TRUE;

    break;

	case 1:
      
	  j = 0;
     
	  Begin:
      
	  
        if(PTasks[i].DaysOfWeek[j] > 6)break;
		if(PTasks[i].DaysOfWeek[j] == st.wDayOfWeek)
		{
		  if(PTasks[i].AtBoot && AtBootTime) return TRUE;
          if(PTasks[i].AtBoot && !AtBootTime) return FALSE;

	 	  if(PTasks[i].StartTime.wHour == st.wHour &&
			 PTasks[i].StartTime.wMinute == st.wMinute)return TRUE;
		 	   
		  
		}
	  
	  j++;
	  
	  if(j < 7) goto Begin;

    break;

    case 2:
      if(PTasks[i].AtBoot && AtBootTime)
	  {
		if(PTasks[i].DayOfMonth == st.wDay)return TRUE;
		else return FALSE;
			
	  }

      if(PTasks[i].DayOfMonth == st.wDay && 
		 PTasks[i].StartTime.wHour == st.wHour &&
		 PTasks[i].StartTime.wMinute == st.wMinute)return TRUE;



    break;

  }

  return FALSE;
}



////////////////////////////////////////////////////////////////////////



void MyShowMessage(char *Text,char *Caption)
{
 PlaySound("AttendantSound",0,SND_ASYNC | SND_ALIAS | SND_NOWAIT | SND_APPLICATION);
 MessageBox(NULL,Text,Caption,MB_OK | MB_ICONINFORMATION | MB_SYSTEMMODAL | MB_SYSTEMMODAL);

}



////////////////////////////////////////////////////////////////////////



DWORD WINAPI MyThreadFunction(LPVOID lpPar)
{
  THREAD_RECORD			*t_r;
  STARTUPINFO			 si;
  PROCESS_INFORMATION 	 pi;
  char					 chBuf[512] = ""; 
  BOOL					 Notify;
  TASK_RECORD	         TaskRec;
  

  t_r = (THREAD_RECORD *)lpPar;

  TaskRec = t_r->tr;
  Notify = t_r->Notify;

  delete lpPar;

  
  if(TaskRec.TaskType == 0)
  {
     strcat(chBuf,"This task hasn't started \n\n");
     strcat(chBuf,TaskRec.szText); 

     
	 if(Notify)MyShowMessage(chBuf,"Attendant");
	 else MyShowMessage(TaskRec.szText,"Attendant");

  }  
  
  if(TaskRec.TaskType == 1)
  {
    ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	CreateProcess(NULL,TaskRec.szFileName,NULL,NULL,FALSE,0,NULL,NULL,&si,&pi);
  }


    	
  return 0;
}



////////////////////////////////////////////////////////////////////////
//
//   .    
//      TaskWasRun
//

void CheckDate()
{
  SYSTEMTIME st;

  GetLocalTime(&st);

  if((st.wYear != CurrentDate.wYear) || 
     (st.wMonth != CurrentDate.wMonth) || 
 	 (st.wDay != CurrentDate.wDay))
  {
    ClearFlagTaskWasRun();
	CurrentDate.wYear = st.wYear;
	CurrentDate.wDay = st.wDay;
	CurrentDate.wMonth = st.wMonth;	

  }

}